package org.jtheque.books.view.panels;

import org.jtheque.primary.view.impl.listeners.CurrentObjectListener;
import org.jtheque.books.view.fb.BookFormBean;
import org.jtheque.core.managers.error.JThequeError;

import javax.swing.DefaultListModel;
import javax.swing.JComponent;

import java.util.Collection;

/**
 * @author Baptiste Wicht
 */
public interface IInfosPanel extends CurrentObjectListener {
    void setEnabled(boolean enabled);

    /**
     * Return the authors model.
     *
     * @return The authors model.
     */
    DefaultListModel getAuthorsModel();

    /**
     * Return the model for the authors of the book.
     *
     * @return The model for the authors of the book.
     */
    DefaultListModel getAuthorsBookModel();

    /**
     * Return the selected indices of the authors model.
     *
     * @return The selected indices of the authors model.
     */
    int[] getSelectedAuthorsIndices();

    /**
     * Return the selected indices of the authors of the book model.
     *
     * @return The selected indices of the authors of the book model.
     */
    int[] getSelectedAuthorsBookIndices();

    /**
     * Fill the formbean with the informations of the panel.
     *
     * @param formBean The formbean to fill.
     */
    void fillFormBean(BookFormBean formBean);

    /**
     * Clear the view.
     */
    void clear();

    /**
     * Validate the view.
     *
     * @param errors The errors to fill.
     */
    void validate(Collection<JThequeError> errors);

    JComponent getImpl();
}
